/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20090123
 *
 * Disassembly of SSDT1.dat, Sat Jul  9 16:47:13 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000266 (614)
 *     Revision         0x01
 *     Checksum         0xA5
 *     OEM ID           "HPQOEM"
 *     OEM Table ID     "SataAhci"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20060912 (537266450)
 */
DefinitionBlock ("SSDT1.aml", "SSDT", 1, "HPQOEM", "SataAhci", 0x00001000)
{
    External (GPIS)
    External (GPIE)
    External (GPL3)
    External (GIV_)
    External (GPL0)
    External (GPSL)
    External (\_SB_.PCI0.SATA, DeviceObj)

    Scope (\_SB.PCI0.SATA)
    {
        Device (PRT0)
        {
            Name (_ADR, 0xFFFF)
            Name (GTH0, Buffer (0x07)
            {
                0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
            })
            Method (_GTF, 0, NotSerialized)
            {
                Store (Buffer (0x07)
                    {
                        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
                    }, GTH0)
                Return (GTH0)
            }
        }

        Device (PRT1)
        {
            Name (_ADR, 0x0001FFFF)
            Name (GTH1, Buffer (0x07)
            {
                0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
            })
            Method (_GTF, 0, NotSerialized)
            {
                Store (Buffer (0x07)
                    {
                        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
                    }, GTH1)
                Return (GTH1)
            }

            Method (_DSM, 4, Serialized)
            {
                Return (HDSM (Arg0, Arg1, Arg2, Arg3))
            }
        }

        Device (PRT2)
        {
            Name (_ADR, 0x0002FFFF)
            Name (GTH2, Buffer (0x07)
            {
                0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
            })
            Method (_GTF, 0, NotSerialized)
            {
                Store (Buffer (0x07)
                    {
                        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
                    }, GTH2)
                Return (GTH2)
            }
        }

        Device (PRT3)
        {
            Name (_ADR, 0x0003FFFF)
            Name (GTF3, Buffer (0x07)
            {
                0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
            })
            Method (_GTF, 0, NotSerialized)
            {
                Store (Buffer (0x07)
                    {
                        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
                    }, GTF3)
                Return (GTF3)
            }
        }

        Device (PRT5)
        {
            Name (_ADR, 0x0005FFFF)
            Name (GTF5, Buffer (0x07)
            {
                0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
            })
            Method (_GTF, 0, NotSerialized)
            {
                Store (Buffer (0x07)
                    {
                        0x00, 0x00, 0x00, 0x00, 0x00, 0xA0, 0x00
                    }, GTF5)
                Return (GTF5)
            }
        }
    }

    Method (HDSM, 4, Serialized)
    {
        If (LEqual (Arg0, Buffer (0x10)
                {
                    /* 0000 */    0x30, 0xEF, 0xFA, 0xBD, 0xBB, 0xAE, 0xDE, 0x11, 
                    /* 0008 */    0x8A, 0x39, 0x08, 0x00, 0x20, 0x0C, 0x9A, 0x66
                }))
        {
            If (LEqual (ToInteger (Arg2), 0x00))
            {
                If (LEqual (ToInteger (Arg1), 0x01))
                {
                    Return (Buffer (0x01)
                    {
                        0x0F
                    })
                }
                Else
                {
                    Return (Buffer (0x01)
                    {
                        0x00
                    })
                }
            }
            Else
            {
                If (LEqual (ToInteger (Arg2), 0x01))
                {
                    Return (0x01)
                }
                Else
                {
                    If (LEqual (ToInteger (Arg2), 0x02))
                    {
                        And (GPSL, Not (0x08), Local0)
                        Store (Local0, GPSL)
                        And (GPL0, 0x08, Local1)
                        If (LEqual (Local1, 0x08))
                        {
                            Or (GIV, 0x08, GIV)
                        }
                        Else
                        {
                            And (GIV, Not (0x08), GIV)
                        }

                        And (GPL3, Not (0x10), Local0)
                        Store (Local0, GPL3)
                        Sleep (0xC8)
                        Or (GPSL, 0x08, GPSL)
                        Return (0x01)
                    }
                    Else
                    {
                        If (LEqual (ToInteger (Arg2), 0x03))
                        {
                            And (GPIE, Not (0x08), GPIE)
                            Or (GPIS, 0x08, GPIS)
                            Or (GPL3, 0x10, Local0)
                            Store (Local0, GPL3)
                            Return (0x01)
                        }
                        Else
                        {
                            Return (0x00)
                        }
                    }
                }
            }
        }
        Else
        {
            Return (0x00)
        }
    }
}

