/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20090123
 *
 * Disassembly of SSDT5.dat, Sat Jul  9 16:47:13 2011
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000BC0 (3008)
 *     Revision         0x01
 *     Checksum         0xC6
 *     OEM ID           "SgRef"
 *     OEM Table ID     "SgTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20060912 (537266450)
 */
DefinitionBlock ("SSDT5.aml", "SSDT", 1, "SgRef", "SgTabl", 0x00001000)
{
    External (HLRS)
    External (PWOK)
    External (PWEN)
    External (IGDS)
    External (DID8, MethodObj)    // 0 Arguments
    External (DDL8)
    External (DID7, MethodObj)    // 0 Arguments
    External (DDL7)
    External (DID6, MethodObj)    // 0 Arguments
    External (DDL6)
    External (DID5, MethodObj)    // 0 Arguments
    External (DDL5)
    External (DID4, MethodObj)    // 0 Arguments
    External (DDL4)
    External (DID3, MethodObj)    // 0 Arguments
    External (DDL3)
    External (DID2, MethodObj)    // 0 Arguments
    External (DDL2)
    External (DID1, MethodObj)    // 0 Arguments
    External (SDDL, IntObj)
    External (DIDL)
    External (NDID)
    External (SGFL)
    External (VRMS, MethodObj)    // 0 Arguments
    External (VRMB, MethodObj)    // 1 Arguments
    External (SGMD)
    External (\EECP, MethodObj)    // 1 Arguments
    External (\GBAS, MethodObj)    // 1 Arguments
    External (\XBAS, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.PEGP, DeviceObj)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.GFX0._DOD, IntObj)
    External (\_SB_.PCI0.GFX0.HDSM, IntObj)
    External (\_SB_.PCI0.PEGP.DGFX, DeviceObj)
    External (\_SB_.PCI0.GFX0.DD08._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD07._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD06._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD05._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD04._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD03._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCM, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BQC, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._BCL, IntObj)
    External (\_SB_.PCI0.GFX0.DD02._ADR, IntObj)
    External (\_SB_.PCI0.GFX0.DD01._ADR, IntObj)
    External (\_SB_.PCI0.PEGP.DGFX._ADR)

    Scope (\_SB.PCI0.GFX0)
    {
        Method (ATPX, 2, Serialized)
        {
            Name (_T_0, Zero)
            Store (Arg0, _T_0)
            If (LEqual (_T_0, 0x00))
            {
                Store (PX00 (), Local0)
            }
            Else
            {
                If (LEqual (_T_0, 0x01))
                {
                    Store (PX01 (), Local0)
                }
                Else
                {
                    If (LEqual (_T_0, 0x02))
                    {
                        PX02 (Arg1)
                    }
                    Else
                    {
                        Store (Buffer (0x0100)
                            {
                                0x00, 0x00
                            }, Local0)
                    }
                }
            }

            Return (Local0)
        }

        Method (PX00, 0, Serialized)
        {
            Store (Buffer (0x0100) {}, Local0)
            CreateWordField (Local0, 0x00, SIZE)
            CreateWordField (Local0, 0x02, IVER)
            CreateDWordField (Local0, 0x04, SFBV)
            Store (0x08, SIZE)
            Store (0x01, IVER)
            If (And (SGMD, 0x0F))
            {
                Store (0x03, SFBV)
            }
            Else
            {
                Store (0x00, SFBV)
            }

            Return (Local0)
        }

        Method (PX01, 0, Serialized)
        {
            Store (Buffer (0x0100) {}, Local0)
            CreateWordField (Local0, 0x00, SIZE)
            CreateDWordField (Local0, 0x02, VFMK)
            CreateDWordField (Local0, 0x06, FLAG)
            Store (0x0A, SIZE)
            Store (0xFF, VFMK)
            Store (0x80, FLAG)
            Return (Local0)
        }

        Method (PX02, 1, Serialized)
        {
            CreateWordField (Arg0, 0x00, SIZI)
            CreateByteField (Arg0, 0x02, PWST)
            And (PWST, 0x01, PWST)
            If (PWST)
            {
                \_SB.PCI0.PEGP.DGFX._ON ()
            }
            Else
            {
                \_SB.PCI0.PEGP.DGFX._OFF ()
            }
        }

        OperationRegion (REVD, SystemMemory, VRMB (VRMS ()), Field (REVD, AnyAcc, NoLock, Preserve)
            {
                SROM,   32, 
                VROM,   512000
            })
        Name (TVGA, Buffer (0xFA00)
        {
            0x00
        })
        Method (ATRM, 2, Serialized)
        {
            Add (Arg0, Arg1, Local0)
            If (LLessEqual (Local0, SROM))
            {
                Multiply (Arg1, 0x08, Local1)
                Multiply (Arg0, 0x08, Local2)
                Store (VROM, TVGA)
                CreateField (TVGA, Local2, Local1, TEMP)
                Name (RETB, Buffer (Arg1) {})
                Store (TEMP, RETB)
                Return (RETB)
            }
            Else
            {
                If (LLess (Arg0, SROM))
                {
                    Subtract (SROM, Arg0, Local3)
                    Multiply (Local3, 0x08, Local1)
                    Multiply (Arg0, 0x08, Local2)
                    Store (VROM, TVGA)
                    CreateField (TVGA, Local2, Local1, TEM)
                    Name (RETC, Buffer (Local3) {})
                    Store (TEM, RETC)
                    Return (RETC)
                }
                Else
                {
                    Name (RETD, Buffer (0x01) {})
                    Return (RETD)
                }
            }
        }

        Method (_DSM, 4, Serialized)
        {
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                If (LEqual (Arg2, 0x00))
                {
                    Name (DRET, Buffer (0x04)
                    {
                        0x00
                    })
                    CreateWordField (DRET, 0x00, F0SS)
                    CreateByteField (DRET, 0x03, TPVE)
                    Store (0x01, F0SS)
                    If (And (SGMD, 0x80))
                    {
                        Store (0x80, TPVE)
                    }

                    Return (DRET)
                }
            }

            If (CondRefOf (\_SB.PCI0.GFX0.HDSM))
            {
                Return (\_SB.PCI0.GFX0.HDSM)
                Arg0
                Arg1
                Arg2
                Arg3
            }

            Return (0x01)
        }

        Method (IDAB, 0, Serialized)
        {
            If (LEqual (And (SGMD, 0x0F), 0x01))
            {
                If (LEqual (SGFL, 0x01))
                {
                    WIID ()
                }
            }
            Else
            {
                Store (0x00, NDID)
                If (LNotEqual (DIDL, Zero))
                {
                    Store (SDDL, DIDL)
                    DID1 ()
                }

                If (LNotEqual (DDL2, Zero))
                {
                    Store (SDDL, DDL2)
                    DID2 ()
                }

                If (LNotEqual (DDL3, Zero))
                {
                    Store (SDDL, DDL3)
                    DID3 ()
                }

                If (LNotEqual (DDL4, Zero))
                {
                    Store (SDDL, DDL4)
                    DID4 ()
                }

                If (LNotEqual (DDL5, Zero))
                {
                    Store (SDDL, DDL5)
                    DID5 ()
                }

                If (LNotEqual (DDL6, Zero))
                {
                    Store (SDDL, DDL6)
                    DID6 ()
                }

                If (LNotEqual (DDL7, Zero))
                {
                    Store (SDDL, DDL7)
                    DID7 ()
                }

                If (LNotEqual (DDL8, Zero))
                {
                    Store (SDDL, DDL8)
                    DID8 ()
                }
            }

            Return (Zero)
        }

        Method (HWID, 0, Serialized)
        {
            Name (TMP9, Package (0x09)
            {
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF, 
                0xFFFFFFFF
            })
            Store (Or (0x00010000, DID1 ()), Index (TMP9, 0x00))
            Store (Or (0x00010000, DID2 ()), Index (TMP9, 0x01))
            Store (Or (0x00010000, DID3 ()), Index (TMP9, 0x02))
            Store (Or (0x00010000, DID4 ()), Index (TMP9, 0x03))
            Store (Or (0x00010000, DID5 ()), Index (TMP9, 0x04))
            Store (Or (0x00010000, DID6 ()), Index (TMP9, 0x05))
            Store (Or (0x00010000, DID7 ()), Index (TMP9, 0x06))
            Store (Or (0x00010000, DID8 ()), Index (TMP9, 0x07))
            Store (0x00, Index (TMP9, 0x08))
            If (And (SGFL, 0x01))
            {
                Store (0x80010306, Index (TMP9, 0x08))
            }

            Return (TMP9)
        }

        Method (WIID, 0, Serialized)
        {
            Name (_T_0, Zero)
            If (LEqual (And (DIDL, 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            If (LEqual (And (DID2 (), 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            If (LEqual (And (DID3 (), 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            If (LEqual (And (DID4 (), 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            If (LEqual (And (DID5 (), 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            If (LEqual (And (DID6 (), 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            If (LEqual (And (DID7 (), 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            If (LEqual (And (DID8 (), 0x0F0F), 0x0306))
            {
                Return (Zero)
            }

            Store (ToInteger (NDID), _T_0)
            If (LEqual (_T_0, 0x01))
            {
                Store (0x80010306, DID2)
                Store (0x02, NDID)
            }
            Else
            {
                If (LEqual (_T_0, 0x02))
                {
                    Store (0x80010306, DID3)
                    Store (0x03, NDID)
                }
                Else
                {
                    If (LEqual (_T_0, 0x03))
                    {
                        Store (0x80010306, DID4)
                        Store (0x04, NDID)
                    }
                    Else
                    {
                        If (LEqual (_T_0, 0x04))
                        {
                            Store (0x80010306, DID5)
                            Store (0x05, NDID)
                        }
                        Else
                        {
                            If (LEqual (_T_0, 0x05))
                            {
                                Store (0x80010306, DID6)
                                Store (0x06, NDID)
                            }
                            Else
                            {
                                If (LEqual (_T_0, 0x06))
                                {
                                    Store (0x80010306, DID7)
                                    Store (0x07, NDID)
                                }
                                Else
                                {
                                    If (LEqual (_T_0, 0x07))
                                    {
                                        Store (0x80010306, DID8)
                                        Store (0x08, NDID)
                                    }
                                    Else
                                    {
                                        If (LEqual (_T_0, 0x08))
                                        {
                                            Store (0x09, NDID)
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }

            Return (Zero)
        }
    }

    Scope (\_SB.PCI0.PEGP)
    {
        OperationRegion (RPCI, PCI_Config, 0x00, 0xF0)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1
        }

        OperationRegion (RPCX, SystemMemory, \XBAS (0x8400), Field (RPCX, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x8214), 
                        Offset (0x8216), 
                LNKS,   4
            })
    }

    Scope (\_SB.PCI0.PEGP.DGFX)
    {
        Name (ELCT, 0x00)
        Name (HVID, 0x00)
        Name (HDID, 0x00)
        OperationRegion (PCIS, PCI_Config, 0x00, 0xF0)
        Field (PCIS, DWordAcc, Lock, Preserve)
        {
            DVID,   16, 
                    Offset (0x2C), 
            SVID,   16, 
            SDID,   16, 
                    Offset (0x4C), 
            WVID,   16, 
            WDID,   16
        }

        OperationRegion (GPIO, SystemIO, \GBAS (0x60), Field (GPIO, ByteAcc, Lock, Preserve)
            {
                        Offset (0x0C), 
                LVL0,   32, 
                        Offset (0x38), 
                LVL1,   32, 
                        Offset (0x48), 
                LVL2,   32
            })
        OperationRegion (PCAP, PCI_Config, \EECP (0x14), Field (PCAP, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                LCTL,   16
            })
        Method (_INI, 0, NotSerialized)
        {
            Store (0x00, \_SB.PCI0.PEGP.DGFX._ADR)
        }

        Method (_ON, 0, Serialized)
        {
            Store (Zero, IGDS)
            SGPO (PWEN, 0x01)
            While (LNotEqual (SGPI (PWOK), 0x01))
            {
                Sleep (0x01)
            }

            Sleep (0x78)
            SGPO (HLRS, 0x01)
            Store (0x00, LNKD)
            While (LLess (LNKS, 0x07))
            {
                Sleep (0x01)
            }

            If (HVID)
            {
                Store (HVID, WVID)
                Store (HDID, WDID)
            }
            Else
            {
                Store (0x103C, WVID)
                Store (0x167F, WDID)
            }

            Or (And (ELCT, 0x43), And (LCTL, 0xFFBC), LCTL)
            Notify (\_SB.PCI0.PEGP, 0x00)
            Return (0x01)
        }

        Method (_OFF, 0, Serialized)
        {
            Store (One, IGDS)
            Store (LCTL, ELCT)
            Store (SVID, HVID)
            Store (SDID, HDID)
            Store (0x01, LNKD)
            While (LNotEqual (LNKS, 0x00))
            {
                Sleep (0x01)
            }

            SGPO (HLRS, 0x00)
            SGPO (PWEN, 0x00)
            Notify (\_SB.PCI0.PEGP, 0x00)
            Return (0x00)
        }

        Method (_STA, 0, Serialized)
        {
            If (And (SGMD, 0x0F))
            {
                If (LEqual (SGPI (PWEN), 0x01))
                {
                    Return (0x0F)
                }

                Return (0x00)
            }

            If (LNotEqual (DVID, 0xFFFF))
            {
                Return (0x0F)
            }

            Return (0x00)
        }

        Method (_DOD, 0, NotSerialized)
        {
            Return (\_SB.PCI0.GFX0._DOD)
        }

        Device (DD01)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD01._ADR)
            }
        }

        Device (DD02)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._ADR)
            }

            Method (_BCL, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCL)
            }

            Method (_BQC, 0, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BQC)
            }

            Method (_BCM, 1, NotSerialized)
            {
                Return (\_SB.PCI0.GFX0.DD02._BCM)
                Arg0
            }
        }

        Device (DD03)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD03._ADR)
            }
        }

        Device (DD04)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD04._ADR)
            }
        }

        Device (DD05)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD05._ADR)
            }
        }

        Device (DD06)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD06._ADR)
            }
        }

        Device (DD07)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD07._ADR)
            }
        }

        Device (DD08)
        {
            Method (_ADR, 0, Serialized)
            {
                Return (\_SB.PCI0.GFX0.DD08._ADR)
            }
        }

        Method (SGPI, 1, Serialized)
        {
            And (Arg0, 0x7F, Arg0)
            If (LLess (Arg0, 0x20))
            {
                Store (\_SB.PCI0.PEGP.DGFX.LVL0, Local0)
                ShiftRight (Local0, Arg0, Local0)
            }
            Else
            {
                If (LLess (Arg0, 0x40))
                {
                    Store (\_SB.PCI0.PEGP.DGFX.LVL1, Local0)
                    ShiftRight (Local0, Subtract (Arg0, 0x20), Local0)
                }
                Else
                {
                    Store (\_SB.PCI0.PEGP.DGFX.LVL2, Local0)
                    ShiftRight (Local0, Subtract (Arg0, 0x40), Local0)
                }
            }

            Return (And (Local0, 0x01))
        }

        Method (SGPO, 2, Serialized)
        {
            And (Arg0, 0x7F, Arg0)
            If (LEqual (Arg1, 0x00))
            {
                Store (0x00, Local3)
            }
            Else
            {
                Store (0x01, Local3)
            }

            If (LLess (Arg0, 0x20))
            {
                ShiftLeft (Local3, Arg0, Local0)
                ShiftLeft (0x01, Arg0, Local1)
                And (\_SB.PCI0.PEGP.DGFX.LVL0, Not (Local1), Local2)
                Or (Local2, Local0, \_SB.PCI0.PEGP.DGFX.LVL0)
            }
            Else
            {
                If (LLess (Arg0, 0x40))
                {
                    ShiftLeft (Local3, Subtract (Arg0, 0x20), Local0)
                    ShiftLeft (0x01, Subtract (Arg0, 0x20), Local1)
                    And (\_SB.PCI0.PEGP.DGFX.LVL1, Not (Local1), Local2)
                    Or (Local2, Local0, \_SB.PCI0.PEGP.DGFX.LVL1)
                }
                Else
                {
                    ShiftLeft (Local3, Subtract (Arg0, 0x40), Local0)
                    ShiftLeft (0x01, Subtract (Arg0, 0x40), Local1)
                    And (\_SB.PCI0.PEGP.DGFX.LVL2, Not (Local1), Local2)
                    Or (Local2, Local0, \_SB.PCI0.PEGP.DGFX.LVL2)
                }
            }

            Return (0x01)
        }
    }
}

